/*
 * This Java source file was generated by the Gradle 'init' task.
 */
package HpdosClient;

import HpdosClient.MessageFormat.MessageConstants;
import HpdosClient.MessageFormat.RequestBuilder;
import hpdos.grpc.NetworkServiceGrpc;
import hpdos.grpc.Packet;
import hpdos.grpc.PacketFormatProto;
import hpdos.grpc.Request;
import io.grpc.ManagedChannel;
import io.grpc.ManagedChannelBuilder;

import java.sql.Timestamp;
import java.time.Instant;
import java.util.*;
import java.util.concurrent.*;

public class ClientRunner {
    public static final int parallelCount = 1;
    private final String clientID;

    public ClientRunner() {
        clientID = UUID.randomUUID().toString();
    }
    public String getGreeting() {
        return "Hello World!";
    }

    public String initClient(String id) {
        final ManagedChannel channel = ManagedChannelBuilder.
                forAddress(ConfigConstants.HOST, ConfigConstants.PORT)
                .usePlaintext()
                .build();
        double averageReadTime = 0, averageWriteTime = 0;
        for (int i = 1; i <= 10; i++) {

            String key = Integer.toString((int) (Math.random() * Integer.MAX_VALUE)), value = "dummy";
            NetworkServiceGrpc.NetworkServiceBlockingStub stub = NetworkServiceGrpc.newBlockingStub(channel);
            ArrayList<Request> request = new ArrayList<>();

            // create a metadata block
            request.add(RequestBuilder.buildRequest(MessageConstants.METADATA_CREATE,
                    0, value.length(), key,
                    0, MessageConstants.METADATA_ACCESS_PRIVATE, this.clientID, value));
            Packet packet = RequestBuilder.buildPacket(request);
            long timestampCreateStart = System.currentTimeMillis();
            Packet response = stub.createMetadata(packet);

            averageWriteTime = (averageWriteTime * (i - 1) + (System.currentTimeMillis() - timestampCreateStart)) / i;
            // read back the metadata
            request.clear();
            request.add(RequestBuilder.buildRequest(MessageConstants.METADATA_READ,
                    0, 0, key, 0, MessageConstants.METADATA_ACCESS_PRIVATE, this.clientID, ""));
            packet = RequestBuilder.buildPacket(request);
            long timestampReadStart = System.currentTimeMillis();
            response = stub.readMetadata(packet);
            averageReadTime = (averageReadTime * (i - 1) + (System.currentTimeMillis() - timestampReadStart)) / i;

//            if (i % 100 == 0)
                System.out.println("Average MDS read time: "
                    + averageReadTime
                    + " ms average create time: " + averageWriteTime + "ms");
        }
        channel.shutdown();
        return id;
    }


    public static void main(String[] args) throws InterruptedException, ExecutionException {
        ClientRunner clientRunner = new ClientRunner();
        System.out.println(clientRunner.getGreeting());
        Thread.sleep(1000);
        ExecutorService executorService = Executors.newFixedThreadPool(parallelCount);
        Set<Callable<String>> callables = new HashSet<>();
        for (int i = 0; i < parallelCount; i++) {
            int finalI = i;
            callables.add(() -> clientRunner.initClient(Integer.toString(finalI)));
        }

        List<Future<String>> futures = executorService.invokeAll(callables);
        for (Future<String> future: futures) {
            System.out.println(future.get());
        }
//        clientRunner.initClient();
    }
}
